open_lib nanosoc_chip_pads.dlib/
open_block nanosoc_chip_pads

set_host_options -max_cores 16 -num_processes 16
set REPORT_DIR ../reports
set LOG_DIR ../logs

set_qor_strategy -stage synthesis -metric timing


# Compile fusion takes about 6.5 hrs to run
set_stage -step synthesis
compile_fusion -to initial_opto

redirect -tee -file $REPORT_DIR/timing_02a_initial_opto_max.rep {report_timing -delay_type max}
redirect -tee -file $REPORT_DIR/timing_02a_initial_opto_min.rep {report_timing -delay_type min}
save_block 

set_stage -step compile_place
compile_fusion -from final_place

redirect -tee -file $REPORT_DIR/timing_02b_compile_fusion_max.rep {report_timing -delay_type max}
redirect -tee -file $REPORT_DIR/timing_02b_compile_fusion_min.rep {report_timing -delay_type min}

redirect -tee -file $REPORT_DIR/qor_02_compile_fusion.rep {report_qor}
save_block
save_lib nanosoc_chip_pads.dlib

exit
