open_lib nanosoc_chip_pads.dlib/
open_block nanosoc_chip_pads

set_host_options -max_cores 16 -num_processes 16
set REPORT_DIR ../reports
set LOG_DIR ../logs

# Clock opt cts
set_stage -step cts

clock_opt -from build_clock -to build_clock
redirect -tee -file $REPORT_DIR/timing_03a_CTS_max.rep {report_timing -delay_type max}
redirect -tee -file $REPORT_DIR/timing_03a_CTS_min.rep {report_timing -delay_type min}
save_block

clock_opt -from route_clock -to route_clock
redirect -tee -file $REPORT_DIR/timing_03b_CTS_max.rep {report_timing -delay_type max}
redirect -tee -file $REPORT_DIR/timing_03b_CTS_min.rep {report_timing -delay_type min}
save_block

set_app_options -name time.aocvm_enable_analysis -value true ;

set_stage -step post_cts_opto
clock_opt -from final_opto -to final_opto
redirect -tee -file $REPORT_DIR/timing_03c_CTS_max.rep {report_timing -delay_type max}
redirect -tee -file $REPORT_DIR/timing_03c_CTS_min.rep {report_timing -delay_type min}

redirect -tee -file $REPORT_DIR/qor_03_CTS.rep {report_qor}

save_block
save_lib nanosoc_chip_pads.dlib

exit